; sys0extr/asm - 05/09/83 - kjw/bqsd
;
;	created 05/09/83	- kjw/bqsd
;	revised 06/01/83	- kjw
;
	PAGE
;
;	External (non-resident) SVC routines
;
;	$EX2DOS - RST $XIT - exit to DOS with error cond
;
$$EX2DOS
	AND	7FH		;any errors?
	LD	B,A		;pass error code
	CALL	NZ,$$ERROR	;else display error
;
;	$JP2DOS - SVC 36 - normal exit to dos
;
$$JP2DOS
	LD	A,_SYS01+_CMD02	;normal system entry
	RST	$OVL
;
;	$DOSCMD - SVC 37 - exec dos command & exit
;
$$DOSCMD
	LD	A,_SYS01+_CMD05	;interpret cmd & exit
	RST	$OVL
;
;	$RETCMD - SVC 38 - exec dos command & return
;
$$RETCMD
	LD	A,_SYS01+_CMD06	;interpret cmd & return
	RST	$OVL
;
;	$CLRXIT - SVC 57 - exit to dos and clear memory
;
$$CLRXIT
	LD	A,_SYS01+_CMD04	;clear ram & abort
	RST	$OVL
;
;	$ABORT - SVC 31 - Abort to Dos
;
$$ABORT
	LD	SP,$STAK	;reset stack
	LD	A,_SYS01+_CMD03 ;abort to dos
	RST	$OVL
;
;	$JPINIT - SVC 109 - init I/O and abort to dos
;
$$JPINIT
	LD	A,_SYS07+_CMD11	;init I/O and abort
	RST	$OVL
;
;	$EVAL - SVC 83 - evaluate command line
;
$$EVAL	LD	A,_SYS01+_CMD08	;evaluate command line
	RST	$OVL
;
;	$FSPEC - SVC 84 - extract filespec
;
$$FSPEC	LD	A,_SYS01+_CMD09	;fetch filespec
	RST	$OVL
;
;	$PARAM - SVC 87 - evaluate user parameters
;
$$PARAM	LD	A,_SYS01+_CMD10	;fetch user parameters
	RST	$OVL
;
;	$FEXT - SVC 88 - add default file extension
;
$$FEXT	LD	A,_SYS01+_CMD11	;add file extension
	RST	$OVL
;
;	$OPEN - SVC 40 - open file/device
;
$$OPEN	LD	A,_SYS02+_CMD02	;open/init file/device
	RST	$OVL
;
;	$RENAME - SVC 47 - rename file
;
$$RENAME
	LD	A,_SYS02+_CMD03	;rename file/device
	RST	$OVL
;
$$KILLO	LD	A,_SYS03+_CMD04	;kill open file
	RST	$OVL
;
;	$CLOSE - SVC 42 - close file/device
;
$$CLOSE	LD	A,_SYS03+_CMD03	;close file/device
	RST	$OVL
;
;	$ERROR - SVC 39 - display error message
;
$$ERROR	LD	A,_SYS05+_CMD02	;display error message
	RST	$OVL
;
;	$ERRMSG - SVC 52 - fetch error message
;
$$ERRMSG
	LD	A,_SYS05+_CMD03	;fetch error message
	RST	$OVL
;
$$DEBUG	PUSH	AF		;save!
	LD	A,_SYS06+_CMD02	;enter debugger
	RST	$OVL
;
;	$KBINIT - SVC 1 - init keyboard
;
$$KBINIT
	LD	A,_SYS07+_CMD02	;keyboard init
	RST	$OVL
;
;	$VDINIT - SVC 7 - init video
;
$$VDINIT
	LD	A,_SYS07+_CMD03	;video init
	RST	$OVL
;
;	$PRINIT - SVC 17 - init printer
;
$$PRINIT
	LD	A,_SYS07+_CMD04	;printer init
	RST	$OVL
;
;	$RS232C - SVC 55 - RS232 control
;
$$RS232C
	LD	A,_SYS07+_CMD05	;RS232 init
	RST	$OVL
;
;	$DATE - SVC 45 - fetch/load time/date
;
$$DATE	LD	A,_SYS07+_CMD06	;fetch time/date
	RST	$OVL
;
;	$PRCTRL - SVC 95 - printer control
;
$$PRCTRL
	LD	A,_SYS07+_CMD07	;printer control
	RST	$OVL
;
;	$ACTRL - SVC 100 - comm line A control
;
$$ACTRL	LD	A,_SYS07+_CMD08	;CL A control
	RST	$OVL
;
;	$BCTRL - SVC 101 - comm line B control
;
$$BCTRL	LD	A,_SYS07+_CMD09	;CL B control
	RST	$OVL
;
;	$INITIO - SVC 0 - init I/O devices
;
$$INITIO
	LD	A,_SYS07+_CMD10	;init all I/O
	RST	$OVL
;
;	$PARSER - SVC 46 - string parser
;
$$PARSER
	LD	A,_SYS08+_CMD02	;parse text string
	RST	$OVL
;
;	$WILD - SVC 51 - wild card parser
;
$$WILD	LD	A,_SYS04+_CMD06	;wild card parse
	RST	$OVL
;
;	$RAMDIR - SVC 53 - ram directory
;
$$RAMDIR
	LD	A,_SYS04+_CMD03	;ram directory
	RST	$OVL
;
;	$RDDIR - SVC 54 - read directory
;
$$RDDIR	LD	A,_SYS04+_CMD04	;read directory
	RST	$OVL
;
;	$DIRSET - SVC 59 - setup for RDDIR
;
$$DIRSET
	LD	A,_SYS04+_CMD05	;setup
	RST	$OVL
;
;	$FILPTR - SVC 58 - fetch file pointers
;
$$FILPTR
	LD	A,_SYS08+_CMD03	;get file pointers
	RST	$OVL
;
;	$DISKID - SVC 15 - read diskette name
;
$$DISKID
	LD	A,_SYS04+_CMD02	;read disk ID
	RST	$OVL
;
;	$SORT - SVC 56 - sort memory
;
$$SORT	LD	A,_SYS08+_CMD04	;sort ram
	RST	$OVL
;
;	$SORT2 - SVC 64 - alternate sort entry
;
$$SORT2
	LD	A,_SYS08+_CMD05	;alternate sort entry
	RST	$OVL
;
